import { defineStore } from 'pinia'
localStorage.setItem(
  'userInfo',
  JSON.stringify(
    {
      "user_id": "1",
      "user_name": "hdpbadmin",
      "user_realname": "系统管理员",
      "lastlogintime": "",
      "user_role_id": 3,
      "user_level": "1",
      "user_role_name": "平台管理员",
      "user_avatar": {
        "big": "http://hdpb_api_311800.bozedu.top/template/default/static/img/user_avatar.png",
        "middle": "http://hdpb_api_311800.bozedu.top/template/default/static/img/user_avatar.png",
        "small": "http://hdpb_api_311800.bozedu.top/template/default/static/img/user_avatar.png"
      },
      "token": "f120iWRd8rkRN8akDSsfKE2GBFvnKtB086WsfJ4rAsyuxCZDUusrYb_aEV2JBECqtTyWTk4o0Wixw_adwXKJ1FqbishGiggn4",
      "user_phone": "13966661111",
      "power": {
        "announce": 0,
        "readonly": 0,
        "activity": 0,
        "dept_master": 0
      },
      "idcard": "",
      "org_info": {
        "dept_id": "5",
        "dept_name": "教育和体育局",
        "oauth_orgType": "0",
        "dept_type": "department",
        "dept_name_full": "",
        "dept_pid": "0",
        "is_matser": "0",
        "dept_role": {
          "role_id": "1",
          "role_name": "教育和体育局成员"
        },
        "dept_full": [
          {
            "dept_id": "4",
            "dept_name": "教育和体育局",
            "oauth_orgType": "0",
            "dept_type": "department"
          }
        ]
      },
      "my_cates": {
        "hh_ids": [],
        "hh_ids_full": []
      }
    }

    // {
    //   "user_id": "319774",
    //   "user_name": "zby011111",
    //   "user_realname": "张八一",
    //   "lastlogintime": "",
    //   "user_role_id": 75,
    //   "user_level": "1",
    //   "user_role_name": "平台用户",
    //   "user_avatar": {
    //     "big": "http://minio.zjjy.xyz/",
    //     "middle": "http://minio.zjjy.xyz/",
    //     "small": "http://minio.zjjy.xyz/"
    //   },
    //   "token": "8c1fMEvRcIspG04P4tbOhYRd_buCgdwmYYKHEKLOyDtEiyFGaRQh_b0mBnTujWAov4blm1YGA5Kfwe7jdD1l1PkzozJEyuwxMEEXzyXA",
    //   "user_phone": "13333333335",
    //   "power": {
    //     "announce": 0,
    //     "readonly": 0,
    //     "activity": 0,
    //     "dept_master": 1
    //   },
    //   "idcard": "333333199001011111",
    //   "org_info": {
    //     "dept_id": "823",
    //     "dept_name": "测试用中心学校",
    //     "oauth_orgType": "1",
    //     "dept_type": "department",
    //     "dept_name_full": "测试用中心学校",
    //     "dept_pid": "1",
    //     "is_matser": "1",
    //     "dept_role": {
    //       "role_id": "2",
    //       "role_name": "教育和体育局管理员"
    //     },
    //     "dept_full": [
    //       {
    //         "dept_id": "1",
    //         "dept_name": "教育和体育局",
    //         "oauth_orgType": "0",
    //         "dept_type": "department"
    //       },
    //       {
    //         "dept_id": "823",
    //         "dept_name": "测试用中心学校",
    //         "oauth_orgType": "1",
    //         "dept_type": "department"
    //       }
    //     ]
    //   },
    //   "my_cates": {
    //     "hh_ids": [],
    //     "hh_ids_full": []
    //   }
    // }
  )
)
/**
 * dept_role.role_id
 * 
  1 局端管理员(最高权限)
  2 局端管理员(普通账号被授予了管理员)
  3 局端普通账号

  4 专家组管理员
  5 专家组下属机构的管理员
  6 专家组普通成员

  7 校机构管理员
  8 校机构下属机构管理员
  9 校机构普通成员
*/
const RoleMap = {
  JLD: [1, 2, 3],
  ZJ: [4, 5, 6],
  XJG: [7, 8, 9],
}
const userInfo = JSON.parse(localStorage.getItem('userInfo'))
const { token, org_info, user_realname, user_avatar, power, user_role_id } = userInfo
const $role_id = org_info.dept_role.role_id * 1

export const user = {
  userInfo,
  token,
  role: org_info.dept_role.role_id * 1,
  real_name: user_realname,
  avatar: user_avatar.small,

  power: power,

  roleName: Object.keys(RoleMap).find((k) =>
    RoleMap[k].includes($role_id)
  ),
  rolePower:
    user_role_id === 3
      ? 'all'
      : (
        Object.keys(power).find((k) => {
          if (k === 'announce') {
            return false
          } else {
            return power[k] === 1
          }
        }
        ) ?? 'none'
      ),

}
export const useUserStore = defineStore('user', {
  state: () => user,
  actions: {
    logout() {
      localStorage.removeItem('userInfo')
      window.open(window.globalVariables.login, '_self');
    },
  },
})
