// 本地开发环境
const local = {
  oss: 'http://hdpb_api_311800.bozedu.top/',
  api: 'http://hdpb_api_311800.bozedu.top/',
  login: 'http://hdpb_web_311800.bozedu.top/home/login.html',
  origin: window.location.origin,
}

// 测试服环境
const development = {
  oss: 'http://hdpb_api_311800.bozedu.top/',
  api: 'http://hdpb_api_311800.bozedu.top/',
  login: 'http://hdpb_web_311800.bozedu.top/home/login.html',
  origin: window.location.origin + '/manage/',
}

// 正式服环境
const production = {
  oss: 'https://openapi.bozedu.net/',
  api: 'https://hdpb.bozedu.net/',
  login: 'https://qqyxt.bozedu.net/app/activityRating/home/login.html',
  origin: window.location.origin + '/manage/',
}

function isWhich() {
  if (window.location.host.includes('localhost')) {
    return local
  } else if (window.location.host.includes('311800')) {
    return development
  } else {
    return production
  }
}
window.globalVariables = isWhich()
