import request from '@/utils/request';

//列表数据
export const queryApi = (choosePage,data = {}) =>
request({
  url: '/common/sjzd/list_tree',
  data:{issubmit:1,cs_pcode:'YXZPDMB',page: choosePage,limit: 10}
});

/**数据添加*/
export const addApi = (data = {}) => request({
  url: '/common/sjzd/add',
  data: {issubmit: 1,common_sjzd:data}
});

//编辑接口
export const editApi = (chooseId,data={}) => request({
  url: '/common/sjzd/edit',
  data: {issubmit: 1,cs_id:chooseId,common_sjzd:data}
});
//详情接口
export const detailApi = (chooseId,data={}) => request({
  url: '/common/sjzd/detail',
  data: {issubmit: 1,cs_id:chooseId}
});
//删除接口
export const deleteApi = (chooseId) => request({
  url: '/common/sjzd/delete',
  data: { issubmit:1,cs_id:chooseId}
});

//搜索接口
export const searchApi = (keyIn_keyword) => request({
  url: '/common/sjzd/index',
  data:keyIn_keyword
})
